import { StreamParser, LanguageSupport, StringStream } from '@codemirror/language';

/**
* Wrapper around the legacy CM5 Solidity language mode
* See: https://github.com/alincode/codemirror-solidity
*/

declare class Context {
    indented: number;
    column: number;
    type: string;
    align: boolean | null;
    prev: Context | null;
    constructor(indented: number, column: number, type: string, align: boolean | null, prev: Context | null);
}
interface State {
    context: Context;
    tokenize: null | ((stream: StringStream, state: State) => string | null);
    indented: number;
    startOfLine: boolean;
    grammar: string | null;
    lastToken: string | null;
    para: string | null;
}
declare const parser: StreamParser<State>;
declare const solidity: LanguageSupport;

export { parser, solidity };
